Attribute VB_Name = "mdlMain"
Option Explicit

Declare Function ShellExecute Lib "shell32.dll" Alias "ShellExecuteA" (ByVal hwnd As Long, ByVal lpOperation As String, ByVal lpFile As String, ByVal lpParameters As String, ByVal lpDirectory As String, ByVal nShowCmd As Long) As Long
Const SW_SHOWNORMAL = 1

Declare Function GetSystemMenu Lib "user32" (ByVal hwnd As Long, ByVal bRevert As Long) As Long
Declare Function GetMenuItemCount Lib "user32" (ByVal hMenu As Long) As Long
Declare Function DrawMenuBar Lib "user32" (ByVal hwnd As Long) As Long
Declare Function RemoveMenu Lib "user32" (ByVal hMenu As Long, ByVal nPosition As Long, ByVal wFlags As Long) As Long
Const MF_BYPOSITION = &H400&
Const MF_REMOVE = &H1000&

Private Declare Function GetDiskFreeSpaceEx Lib "kernel32" Alias "GetDiskFreeSpaceExA" (ByVal lpRootPathName As String, lpFreeBytesAvailableToCaller As Currency, lpTotalNumberOfBytes As Currency, lpTotalNumberOfFreeBytes As Currency) As Long

' Reg Key Security Options...
Const READ_CONTROL = &H20000
Const KEY_QUERY_VALUE = &H1
Const KEY_SET_VALUE = &H2
Const KEY_CREATE_SUB_KEY = &H4
Const KEY_ENUMERATE_SUB_KEYS = &H8
Const KEY_NOTIFY = &H10
Const KEY_CREATE_LINK = &H20
Const KEY_ALL_ACCESS = KEY_QUERY_VALUE + KEY_SET_VALUE + _
                       KEY_CREATE_SUB_KEY + KEY_ENUMERATE_SUB_KEYS + _
                       KEY_NOTIFY + KEY_CREATE_LINK + READ_CONTROL
                     
' Reg Key ROOT Types...
Const HKEY_LOCAL_MACHINE = &H80000002
Const ERROR_SUCCESS = 0
Const REG_SZ = 1                         ' Unicode nul terminated string
Const REG_DWORD = 4                      ' 32-bit number

Const gREGKEYSYSINFOLOC = "SOFTWARE\Microsoft\Shared Tools Location"
Const gREGVALSYSINFOLOC = "MSINFO"
Const gREGKEYSYSINFO = "SOFTWARE\Microsoft\Shared Tools\MSINFO"
Const gREGVALSYSINFO = "PATH"

Private Declare Function RegOpenKeyEx Lib "advapi32" Alias "RegOpenKeyExA" (ByVal hKey As Long, ByVal lpSubKey As String, ByVal ulOptions As Long, ByVal samDesired As Long, ByRef phkResult As Long) As Long
Private Declare Function RegQueryValueEx Lib "advapi32" Alias "RegQueryValueExA" (ByVal hKey As Long, ByVal lpValueName As String, ByVal lpReserved As Long, ByRef lpType As Long, ByVal lpData As String, ByRef lpcbData As Long) As Long
Private Declare Function RegCloseKey Lib "advapi32" (ByVal hKey As Long) As Long

Function CenterForm(frm As Form)
    ' Center Form in the screen
    frm.Move (Screen.Width - frm.Width) \ 2, (Screen.Height - frm.Height) \ 2
End Function

Function LaunchSite(frm As Form, sAddress As String)
    ShellExecute frm.hwnd, vbNullString, sAddress, vbNullString, "C:\", SW_SHOWNORMAL
End Function

Function EndApp(Message As Boolean)
Dim sPrompt As String
Dim sTitle As String
Dim vStyle As Variant
Dim sMsg As String

    If Message = True Then
        ' Message Prompt
        sPrompt = "Are you sure you want to exit Drive Browser?"
        ' Message Title
        sTitle = "Quit"
        ' Message Style
        vStyle = vbQuestion + vbYesNo
        ' Message box
        sMsg = MsgBox(sPrompt, vStyle, sTitle)
        ' If "Yes"...
        If sMsg = vbYes Then
            ' ... unload all the forms
            UnloadAllForms
            End
        End If
    Else
        ' Unload all the forms
        UnloadAllForms
        End
    End If
End Function

Sub UnloadAllForms()
    ' Unload all Forms
    Unload frmAbout
    Unload frmMain
End Sub

Function DisableXButton(frm As Form)
Dim hSysMenu As Long
Dim nCnt As Long
    
    ' Get handle to our form's system menu
    ' (Restore, Maximize, Move, close etc.)
    hSysMenu = GetSystemMenu(frm.hwnd, False)

    If hSysMenu Then
        ' Get System menu's menu count
        nCnt = GetMenuItemCount(hSysMenu)
        If nCnt Then
            ' Menu count is based on 0 (0, 1, 2, 3...)
            RemoveMenu hSysMenu, nCnt - 1, MF_BYPOSITION Or MF_REMOVE
            RemoveMenu hSysMenu, nCnt - 2, MF_BYPOSITION Or MF_REMOVE ' Remove the seperator
            DrawMenuBar frm.hwnd
        End If
    End If
End Function

Function ShowDriveType(drvpath) As String
    Dim fs, d, s, t
    Set fs = CreateObject("Scripting.FileSystemObject")
    Set d = fs.GetDrive(drvpath)
    Select Case d.DriveType
        Case 0: t = "Unknown"
        Case 1: t = "Removable"
        Case 2: t = "Fixed"
        Case 3: t = "Network"
        Case 4: t = "CD-ROM"
        Case 5: t = "RAM Disk"
    End Select
    s = t
    ShowDriveType = s
End Function

Function AddDrive(lList As ListView, sDrive As String)
Dim sType As String
Dim itm As ListItem

    Screen.MousePointer = vbHourglass
   
    sType = ShowDriveType(sDrive)
    If sType = "Unknown" Then
        Set itm = lList.ListItems.Add()
        itm.Key = sDrive
        itm.Text = UCase(sDrive)
        itm.SubItems(1) = GetDriveSpace(sDrive)
        itm.SubItems(2) = GetDriveFreeSpace(sDrive)
        itm.SubItems(3) = GetDriveUsedSpace(sDrive)
        itm.SubItems(4) = "Unknown"
    ElseIf sType = "Removable" Then
        Set itm = lList.ListItems.Add()
        itm.SmallIcon = "removable"
        itm.Key = sDrive
        itm.Text = UCase(sDrive)
        itm.SubItems(1) = GetDriveSpace(sDrive)
        itm.SubItems(2) = GetDriveFreeSpace(sDrive)
        itm.SubItems(3) = GetDriveUsedSpace(sDrive)
        itm.SubItems(4) = "Removable"
    ElseIf sType = "Fixed" Then
        Set itm = lList.ListItems.Add()
        itm.SmallIcon = "drive"
        itm.Key = sDrive
        itm.Text = UCase(sDrive)
        itm.SubItems(1) = GetDriveSpace(sDrive)
        itm.SubItems(2) = GetDriveFreeSpace(sDrive)
        itm.SubItems(3) = GetDriveUsedSpace(sDrive)
        itm.SubItems(4) = "Fixed"
    ElseIf sType = "Network" Then
        Set itm = lList.ListItems.Add()
        itm.SmallIcon = "network"
        itm.Key = sDrive
        itm.Text = UCase(sDrive)
        itm.SubItems(1) = GetDriveSpace(sDrive)
        itm.SubItems(2) = GetDriveFreeSpace(sDrive)
        itm.SubItems(3) = GetDriveUsedSpace(sDrive)
        itm.SubItems(4) = "Network"
    ElseIf sType = "CD-ROM" Then
        Set itm = lList.ListItems.Add()
        itm.SmallIcon = "cdrom"
        itm.Key = sDrive
        itm.Text = UCase(sDrive)
        itm.SubItems(1) = GetDriveSpace(sDrive)
        itm.SubItems(2) = GetDriveFreeSpace(sDrive)
        itm.SubItems(3) = GetDriveUsedSpace(sDrive)
        itm.SubItems(4) = "CD-Rom"
    ElseIf sType = "RAM Disk" Then
        Set itm = lList.ListItems.Add()
        itm.SmallIcon = "drive"
        itm.Key = sDrive
        itm.Text = UCase(sDrive)
        itm.SubItems(1) = GetDriveSpace(sDrive)
        itm.SubItems(2) = GetDriveFreeSpace(sDrive)
        itm.SubItems(3) = GetDriveUsedSpace(sDrive)
        itm.SubItems(4) = "RAM Disk"
    Else
        Set itm = lList.ListItems.Add()
        itm.Key = sDrive
        itm.Text = UCase(sDrive)
        itm.SubItems(1) = GetDriveSpace(sDrive)
        itm.SubItems(2) = GetDriveFreeSpace(sDrive)
        itm.SubItems(3) = GetDriveUsedSpace(sDrive)
        itm.SubItems(4) = "(Can't Get Type)"
    End If
    Screen.MousePointer = vbNormal
End Function


Function GetDriveSpace(sDrive As String) As Variant
Dim r As Long
Dim BytesFreeToCalller As Currency
Dim TotalBytes As Currency
Dim TotalFreeBytes As Currency
Dim TotalBytesUsed As Currency
Dim sUsage As Variant
    
    'get the drive's disk parameters
    Call GetDiskFreeSpaceEx(sDrive, BytesFreeToCalller, TotalBytes, TotalFreeBytes)
    GetDriveSpace = Format$(TotalBytes * 10000, "###,###,###,##0")

    ' By Bytes
    If Len(GetDriveSpace) = 5 Or Len(GetDriveSpace) >= 5 Then
        If Len(GetDriveSpace) = 5 Then
            GetDriveSpace = CStr(GetDriveSpace)
            sUsage = Left(GetDriveSpace, 1)
            GetDriveSpace = sUsage & " MB"
        ElseIf Len(GetDriveSpace) = 6 Then
            GetDriveSpace = CStr(GetDriveSpace)
            sUsage = Left(GetDriveSpace, 2)
            GetDriveSpace = sUsage & " MB"
        ElseIf Len(GetDriveSpace) = 7 Then
            GetDriveSpace = CStr(GetDriveSpace)
            sUsage = Left(GetDriveSpace, 3)
            GetDriveSpace = sUsage & " MB"
        End If
    End If

    ' By Megabytes
    If Len(GetDriveSpace) = 9 Or Len(GetDriveSpace) >= 9 Then
        If Len(GetDriveSpace) = 9 Then
            GetDriveSpace = CStr(GetDriveSpace)
            sUsage = Left(GetDriveSpace, 1)
            GetDriveSpace = sUsage & " MB"
        ElseIf Len(GetDriveSpace) = 10 Then
            GetDriveSpace = CStr(GetDriveSpace)
            sUsage = Left(GetDriveSpace, 2)
            GetDriveSpace = sUsage & " MB"
        ElseIf Len(GetDriveSpace) = 11 Then
            GetDriveSpace = CStr(GetDriveSpace)
            sUsage = Left(GetDriveSpace, 3)
            GetDriveSpace = sUsage & " MB"
        End If
    End If

    ' By Gigabytes
    If Len(GetDriveSpace) = 13 Or Len(GetDriveSpace) >= 13 Then
        If Len(GetDriveSpace) = 13 Then
            GetDriveSpace = CStr(GetDriveSpace)
            sUsage = Left(GetDriveSpace, 1)
            GetDriveSpace = sUsage & " GB"
        ElseIf Len(GetDriveSpace) = 14 Then
            GetDriveSpace = CStr(GetDriveSpace)
            sUsage = Left(GetDriveSpace, 2)
            GetDriveSpace = sUsage & " GB"
        ElseIf Len(GetDriveSpace) = 15 Then
            GetDriveSpace = CStr(GetDriveSpace)
            sUsage = Left(GetDriveSpace, 3)
            GetDriveSpace = sUsage & " GB"
        End If
    End If
End Function

Function GetDriveFreeSpace(sDrive As String) As Variant
Dim r As Long
Dim BytesFreeToCalller As Currency
Dim TotalBytes As Currency
Dim TotalFreeBytes As Currency
Dim TotalBytesUsed As Currency
Dim sUsage As Variant

    'get the drive's disk parameters
    Call GetDiskFreeSpaceEx(sDrive, BytesFreeToCalller, TotalBytes, TotalFreeBytes)
    GetDriveFreeSpace = Format$(BytesFreeToCalller * 10000, "###,###,###,##0")
    
    ' By Bytes
    If Len(GetDriveFreeSpace) = 5 Or Len(GetDriveFreeSpace) >= 5 Then
        If Len(GetDriveFreeSpace) = 5 Then
            GetDriveFreeSpace = CStr(GetDriveFreeSpace)
            sUsage = Left(GetDriveFreeSpace, 1)
            GetDriveFreeSpace = sUsage & " MB"
        ElseIf Len(GetDriveFreeSpace) = 6 Then
            GetDriveFreeSpace = CStr(GetDriveFreeSpace)
            sUsage = Left(GetDriveFreeSpace, 2)
            GetDriveFreeSpace = sUsage & " MB"
        ElseIf Len(GetDriveFreeSpace) = 7 Then
            GetDriveFreeSpace = CStr(GetDriveFreeSpace)
            sUsage = Left(GetDriveFreeSpace, 3)
            GetDriveFreeSpace = sUsage & " MB"
        End If
    End If

    ' By Megabytes
    If Len(GetDriveFreeSpace) = 9 Or Len(GetDriveFreeSpace) >= 9 Then
        If Len(GetDriveFreeSpace) = 9 Then
            GetDriveFreeSpace = CStr(GetDriveFreeSpace)
            sUsage = Left(GetDriveFreeSpace, 1)
            GetDriveFreeSpace = sUsage & " MB"
        ElseIf Len(GetDriveFreeSpace) = 10 Then
            GetDriveFreeSpace = CStr(GetDriveFreeSpace)
            sUsage = Left(GetDriveFreeSpace, 2)
            GetDriveFreeSpace = sUsage & " MB"
        ElseIf Len(GetDriveFreeSpace) = 11 Then
            GetDriveFreeSpace = CStr(GetDriveFreeSpace)
            sUsage = Left(GetDriveFreeSpace, 3)
            GetDriveFreeSpace = sUsage & " MB"
        End If
    End If

    ' By Gigabytes
    If Len(GetDriveFreeSpace) = 13 Or Len(GetDriveFreeSpace) >= 13 Then
        If Len(GetDriveFreeSpace) = 13 Then
            GetDriveFreeSpace = CStr(GetDriveFreeSpace)
            sUsage = Left(GetDriveFreeSpace, 1)
            GetDriveFreeSpace = sUsage & " GB"
        ElseIf Len(GetDriveFreeSpace) = 14 Then
            GetDriveFreeSpace = CStr(GetDriveFreeSpace)
            sUsage = Left(GetDriveFreeSpace, 2)
            GetDriveFreeSpace = sUsage & " GB"
        ElseIf Len(GetDriveFreeSpace) = 15 Then
            GetDriveFreeSpace = CStr(GetDriveFreeSpace)
            sUsage = Left(GetDriveFreeSpace, 3)
            GetDriveFreeSpace = sUsage & " GB"
        End If
    End If
End Function

Function GetDriveUsedSpace(sDrive As String) As Variant
Dim r As Long
Dim BytesFreeToCalller As Currency
Dim TotalBytes As Currency
Dim TotalFreeBytes As Currency
Dim TotalBytesUsed As Currency
Dim sUsage As Variant

    'get the drive's disk parameters
    Call GetDiskFreeSpaceEx(sDrive, BytesFreeToCalller, TotalBytes, TotalFreeBytes)
    GetDriveUsedSpace = Format$((TotalBytes - TotalFreeBytes) * 10000, "###,###,###,##0")
    
    ' By Bytes
    If Len(GetDriveUsedSpace) = 5 Or Len(GetDriveUsedSpace) >= 5 Then
        If Len(GetDriveUsedSpace) = 5 Then
            GetDriveUsedSpace = CStr(GetDriveUsedSpace)
            sUsage = Left(GetDriveUsedSpace, 1)
            GetDriveUsedSpace = sUsage & " MB"
        ElseIf Len(GetDriveUsedSpace) = 6 Then
            GetDriveUsedSpace = CStr(GetDriveUsedSpace)
            sUsage = Left(GetDriveUsedSpace, 2)
            GetDriveUsedSpace = sUsage & " MB"
        ElseIf Len(GetDriveUsedSpace) = 7 Then
            GetDriveUsedSpace = CStr(GetDriveUsedSpace)
            sUsage = Left(GetDriveUsedSpace, 3)
            GetDriveUsedSpace = sUsage & " MB"
        End If
    End If

    ' By Megabytes
    If Len(GetDriveUsedSpace) = 9 Or Len(GetDriveUsedSpace) >= 9 Then
        If Len(GetDriveUsedSpace) = 9 Then
            GetDriveUsedSpace = CStr(GetDriveUsedSpace)
            sUsage = Left(GetDriveUsedSpace, 1)
            GetDriveUsedSpace = sUsage & " MB"
        ElseIf Len(GetDriveUsedSpace) = 10 Then
            GetDriveUsedSpace = CStr(GetDriveUsedSpace)
            sUsage = Left(GetDriveUsedSpace, 2)
            GetDriveUsedSpace = sUsage & " MB"
        ElseIf Len(GetDriveUsedSpace) = 11 Then
            GetDriveUsedSpace = CStr(GetDriveUsedSpace)
            sUsage = Left(GetDriveUsedSpace, 3)
            GetDriveUsedSpace = sUsage & " MB"
        End If
    End If

    ' By Gigabytes
    If Len(GetDriveUsedSpace) = 13 Or Len(GetDriveUsedSpace) >= 13 Then
        If Len(GetDriveUsedSpace) = 13 Then
            GetDriveUsedSpace = CStr(GetDriveUsedSpace)
            sUsage = Left(GetDriveUsedSpace, 1)
            GetDriveUsedSpace = sUsage & " GB"
        ElseIf Len(GetDriveUsedSpace) = 14 Then
            GetDriveUsedSpace = CStr(GetDriveUsedSpace)
            sUsage = Left(GetDriveUsedSpace, 2)
            GetDriveUsedSpace = sUsage & " GB"
        ElseIf Len(GetDriveUsedSpace) = 15 Then
            GetDriveUsedSpace = CStr(GetDriveUsedSpace)
            sUsage = Left(GetDriveUsedSpace, 3)
            GetDriveUsedSpace = sUsage & " GB"
        End If
    End If
End Function

Public Sub StartSysInfo()
    On Error GoTo SysInfoErr
  
    Dim rc As Long
    Dim SysInfoPath As String
    
    ' Try To Get System Info Program Path\Name From Registry...
    If GetKeyValue(HKEY_LOCAL_MACHINE, gREGKEYSYSINFO, gREGVALSYSINFO, SysInfoPath) Then
    ' Try To Get System Info Program Path Only From Registry...
    ElseIf GetKeyValue(HKEY_LOCAL_MACHINE, gREGKEYSYSINFOLOC, gREGVALSYSINFOLOC, SysInfoPath) Then
        ' Validate Existance Of Known 32 Bit File Version
        If (Dir(SysInfoPath & "\MSINFO32.EXE") <> "") Then
            SysInfoPath = SysInfoPath & "\MSINFO32.EXE"
            
        ' Error - File Can Not Be Found...
        Else
            GoTo SysInfoErr
        End If
    ' Error - Registry Entry Can Not Be Found...
    Else
        GoTo SysInfoErr
    End If
    
    Call Shell(SysInfoPath, vbNormalFocus)
    
    Exit Sub
SysInfoErr:
    MsgBox "System Information Is Unavailable At This Time", vbOKOnly
End Sub

Public Function GetKeyValue(KeyRoot As Long, KeyName As String, SubKeyRef As String, ByRef KeyVal As String) As Boolean
    Dim i As Long                                           ' Loop Counter
    Dim rc As Long                                          ' Return Code
    Dim hKey As Long                                        ' Handle To An Open Registry Key
    Dim hDepth As Long                                      '
    Dim KeyValType As Long                                  ' Data Type Of A Registry Key
    Dim tmpVal As String                                    ' Tempory Storage For A Registry Key Value
    Dim KeyValSize As Long                                  ' Size Of Registry Key Variable
    '------------------------------------------------------------
    ' Open RegKey Under KeyRoot {HKEY_LOCAL_MACHINE...}
    '------------------------------------------------------------
    rc = RegOpenKeyEx(KeyRoot, KeyName, 0, KEY_ALL_ACCESS, hKey) ' Open Registry Key
    
    If (rc <> ERROR_SUCCESS) Then GoTo GetKeyError          ' Handle Error...
    
    tmpVal = String$(1024, 0)                             ' Allocate Variable Space
    KeyValSize = 1024                                       ' Mark Variable Size
    
    '------------------------------------------------------------
    ' Retrieve Registry Key Value...
    '------------------------------------------------------------
    rc = RegQueryValueEx(hKey, SubKeyRef, 0, _
                         KeyValType, tmpVal, KeyValSize)    ' Get/Create Key Value
                        
    If (rc <> ERROR_SUCCESS) Then GoTo GetKeyError          ' Handle Errors
    
    If (Asc(Mid(tmpVal, KeyValSize, 1)) = 0) Then           ' Win95 Adds Null Terminated String...
        tmpVal = Left(tmpVal, KeyValSize - 1)               ' Null Found, Extract From String
    Else                                                    ' WinNT Does NOT Null Terminate String...
        tmpVal = Left(tmpVal, KeyValSize)                   ' Null Not Found, Extract String Only
    End If
    '------------------------------------------------------------
    ' Determine Key Value Type For Conversion...
    '------------------------------------------------------------
    Select Case KeyValType                                  ' Search Data Types...
    Case REG_SZ                                             ' String Registry Key Data Type
        KeyVal = tmpVal                                     ' Copy String Value
    Case REG_DWORD                                          ' Double Word Registry Key Data Type
        For i = Len(tmpVal) To 1 Step -1                    ' Convert Each Bit
            KeyVal = KeyVal + Hex(Asc(Mid(tmpVal, i, 1)))   ' Build Value Char. By Char.
        Next
        KeyVal = Format$("&h" + KeyVal)                     ' Convert Double Word To String
    End Select
    
    GetKeyValue = True                                      ' Return Success
    rc = RegCloseKey(hKey)                                  ' Close Registry Key
    Exit Function                                           ' Exit
    
GetKeyError:      ' Cleanup After An Error Has Occured...
    KeyVal = ""                                             ' Set Return Val To Empty String
    GetKeyValue = False                                     ' Return Failure
    rc = RegCloseKey(hKey)                                  ' Close Registry Key
End Function

Function LoadTextFile(sFile As String, Label As Boolean, textbox As Control)
Dim LineOfText As String
Dim AllText As String
Dim Wrap As String

    Wrap = Chr(13) + Chr(10)
    
    ' Load text *.str file
    Open sFile For Input As #1
    Do Until EOF(1)
        Line Input #1, LineOfText
        AllText = AllText & LineOfText & Wrap
    Loop
    If Label = True Then
        textbox.Caption = AllText
    Else
        textbox.Text = AllText
    End If
    Close #1
End Function

